<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/regex-syntax-0.6.27/src/parser.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>parser.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../regex_syntax/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../regex_syntax/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../regex_syntax/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::ast</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::hir</span>;

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::Result</span>;

<span class="doccomment">/// A builder for a regular expression parser.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This builder permits modifying configuration options for the parser.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This type combines the builder options for both the</span>
<span class="doccomment">/// [AST `ParserBuilder`](ast/parse/struct.ParserBuilder.html)</span>
<span class="doccomment">/// and the</span>
<span class="doccomment">/// [HIR `TranslatorBuilder`](hir/translate/struct.TranslatorBuilder.html).</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>, <span class="ident">Default</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">ParserBuilder</span> {
    <span class="ident">ast</span>: <span class="ident">ast::parse::ParserBuilder</span>,
    <span class="ident">hir</span>: <span class="ident">hir::translate::TranslatorBuilder</span>,
}

<span class="kw">impl</span> <span class="ident">ParserBuilder</span> {
    <span class="doccomment">/// Create a new parser builder with a default configuration.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>() -&gt; <span class="ident">ParserBuilder</span> {
        <span class="ident">ParserBuilder::default</span>()
    }

    <span class="doccomment">/// Build a parser from this configuration with the given pattern.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">build</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">Parser</span> {
        <span class="ident">Parser</span> { <span class="ident">ast</span>: <span class="self">self</span>.<span class="ident">ast</span>.<span class="ident">build</span>(), <span class="ident">hir</span>: <span class="self">self</span>.<span class="ident">hir</span>.<span class="ident">build</span>() }
    }

    <span class="doccomment">/// Set the nesting limit for this parser.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The nesting limit controls how deep the abstract syntax tree is allowed</span>
    <span class="doccomment">/// to be. If the AST exceeds the given limit (e.g., with too many nested</span>
    <span class="doccomment">/// groups), then an error is returned by the parser.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The purpose of this limit is to act as a heuristic to prevent stack</span>
    <span class="doccomment">/// overflow for consumers that do structural induction on an `Ast` using</span>
    <span class="doccomment">/// explicit recursion. While this crate never does this (instead using</span>
    <span class="doccomment">/// constant stack space and moving the call stack to the heap), other</span>
    <span class="doccomment">/// crates may.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This limit is not checked until the entire Ast is parsed. Therefore,</span>
    <span class="doccomment">/// if callers want to put a limit on the amount of heap space used, then</span>
    <span class="doccomment">/// they should impose a limit on the length, in bytes, of the concrete</span>
    <span class="doccomment">/// pattern string. In particular, this is viable since this parser</span>
    <span class="doccomment">/// implementation will limit itself to heap space proportional to the</span>
    <span class="doccomment">/// length of the pattern string.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Note that a nest limit of `0` will return a nest limit error for most</span>
    <span class="doccomment">/// patterns but not all. For example, a nest limit of `0` permits `a` but</span>
    <span class="doccomment">/// not `ab`, since `ab` requires a concatenation, which results in a nest</span>
    <span class="doccomment">/// depth of `1`. In general, a nest limit is not something that manifests</span>
    <span class="doccomment">/// in an obvious way in the concrete syntax, therefore, it should not be</span>
    <span class="doccomment">/// used in a granular way.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">nest_limit</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">limit</span>: <span class="ident">u32</span>) -&gt; <span class="kw-2">&amp;mut</span> <span class="ident">ParserBuilder</span> {
        <span class="self">self</span>.<span class="ident">ast</span>.<span class="ident">nest_limit</span>(<span class="ident">limit</span>);
        <span class="self">self</span>
    }

    <span class="doccomment">/// Whether to support octal syntax or not.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Octal syntax is a little-known way of uttering Unicode codepoints in</span>
    <span class="doccomment">/// a regular expression. For example, `a`, `\x61`, `\u0061` and</span>
    <span class="doccomment">/// `\141` are all equivalent regular expressions, where the last example</span>
    <span class="doccomment">/// shows octal syntax.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// While supporting octal syntax isn&#39;t in and of itself a problem, it does</span>
    <span class="doccomment">/// make good error messages harder. That is, in PCRE based regex engines,</span>
    <span class="doccomment">/// syntax like `\0` invokes a backreference, which is explicitly</span>
    <span class="doccomment">/// unsupported in Rust&#39;s regex engine. However, many users expect it to</span>
    <span class="doccomment">/// be supported. Therefore, when octal support is disabled, the error</span>
    <span class="doccomment">/// message will explicitly mention that backreferences aren&#39;t supported.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Octal syntax is disabled by default.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">octal</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">yes</span>: <span class="ident">bool</span>) -&gt; <span class="kw-2">&amp;mut</span> <span class="ident">ParserBuilder</span> {
        <span class="self">self</span>.<span class="ident">ast</span>.<span class="ident">octal</span>(<span class="ident">yes</span>);
        <span class="self">self</span>
    }

    <span class="doccomment">/// When enabled, the parser will permit the construction of a regular</span>
    <span class="doccomment">/// expression that may match invalid UTF-8.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// When disabled (the default), the parser is guaranteed to produce</span>
    <span class="doccomment">/// an expression that will only ever match valid UTF-8 (otherwise, the</span>
    <span class="doccomment">/// parser will return an error).</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Perhaps surprisingly, when invalid UTF-8 isn&#39;t allowed, a negated ASCII</span>
    <span class="doccomment">/// word boundary (uttered as `(?-u:\B)` in the concrete syntax) will cause</span>
    <span class="doccomment">/// the parser to return an error. Namely, a negated ASCII word boundary</span>
    <span class="doccomment">/// can result in matching positions that aren&#39;t valid UTF-8 boundaries.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">allow_invalid_utf8</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">yes</span>: <span class="ident">bool</span>) -&gt; <span class="kw-2">&amp;mut</span> <span class="ident">ParserBuilder</span> {
        <span class="self">self</span>.<span class="ident">hir</span>.<span class="ident">allow_invalid_utf8</span>(<span class="ident">yes</span>);
        <span class="self">self</span>
    }

    <span class="doccomment">/// Enable verbose mode in the regular expression.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// When enabled, verbose mode permits insignificant whitespace in many</span>
    <span class="doccomment">/// places in the regular expression, as well as comments. Comments are</span>
    <span class="doccomment">/// started using `#` and continue until the end of the line.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// By default, this is disabled. It may be selectively enabled in the</span>
    <span class="doccomment">/// regular expression by using the `x` flag regardless of this setting.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">ignore_whitespace</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">yes</span>: <span class="ident">bool</span>) -&gt; <span class="kw-2">&amp;mut</span> <span class="ident">ParserBuilder</span> {
        <span class="self">self</span>.<span class="ident">ast</span>.<span class="ident">ignore_whitespace</span>(<span class="ident">yes</span>);
        <span class="self">self</span>
    }

    <span class="doccomment">/// Enable or disable the case insensitive flag by default.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// By default this is disabled. It may alternatively be selectively</span>
    <span class="doccomment">/// enabled in the regular expression itself via the `i` flag.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">case_insensitive</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">yes</span>: <span class="ident">bool</span>) -&gt; <span class="kw-2">&amp;mut</span> <span class="ident">ParserBuilder</span> {
        <span class="self">self</span>.<span class="ident">hir</span>.<span class="ident">case_insensitive</span>(<span class="ident">yes</span>);
        <span class="self">self</span>
    }

    <span class="doccomment">/// Enable or disable the multi-line matching flag by default.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// By default this is disabled. It may alternatively be selectively</span>
    <span class="doccomment">/// enabled in the regular expression itself via the `m` flag.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">multi_line</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">yes</span>: <span class="ident">bool</span>) -&gt; <span class="kw-2">&amp;mut</span> <span class="ident">ParserBuilder</span> {
        <span class="self">self</span>.<span class="ident">hir</span>.<span class="ident">multi_line</span>(<span class="ident">yes</span>);
        <span class="self">self</span>
    }

    <span class="doccomment">/// Enable or disable the &quot;dot matches any character&quot; flag by default.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// By default this is disabled. It may alternatively be selectively</span>
    <span class="doccomment">/// enabled in the regular expression itself via the `s` flag.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">dot_matches_new_line</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">yes</span>: <span class="ident">bool</span>) -&gt; <span class="kw-2">&amp;mut</span> <span class="ident">ParserBuilder</span> {
        <span class="self">self</span>.<span class="ident">hir</span>.<span class="ident">dot_matches_new_line</span>(<span class="ident">yes</span>);
        <span class="self">self</span>
    }

    <span class="doccomment">/// Enable or disable the &quot;swap greed&quot; flag by default.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// By default this is disabled. It may alternatively be selectively</span>
    <span class="doccomment">/// enabled in the regular expression itself via the `U` flag.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">swap_greed</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">yes</span>: <span class="ident">bool</span>) -&gt; <span class="kw-2">&amp;mut</span> <span class="ident">ParserBuilder</span> {
        <span class="self">self</span>.<span class="ident">hir</span>.<span class="ident">swap_greed</span>(<span class="ident">yes</span>);
        <span class="self">self</span>
    }

    <span class="doccomment">/// Enable or disable the Unicode flag (`u`) by default.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// By default this is **enabled**. It may alternatively be selectively</span>
    <span class="doccomment">/// disabled in the regular expression itself via the `u` flag.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Note that unless `allow_invalid_utf8` is enabled (it&#39;s disabled by</span>
    <span class="doccomment">/// default), a regular expression will fail to parse if Unicode mode is</span>
    <span class="doccomment">/// disabled and a sub-expression could possibly match invalid UTF-8.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">unicode</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">yes</span>: <span class="ident">bool</span>) -&gt; <span class="kw-2">&amp;mut</span> <span class="ident">ParserBuilder</span> {
        <span class="self">self</span>.<span class="ident">hir</span>.<span class="ident">unicode</span>(<span class="ident">yes</span>);
        <span class="self">self</span>
    }
}

<span class="doccomment">/// A convenience parser for regular expressions.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This parser takes as input a regular expression pattern string (the</span>
<span class="doccomment">/// &quot;concrete syntax&quot;) and returns a high-level intermediate representation</span>
<span class="doccomment">/// (the HIR) suitable for most types of analysis. In particular, this parser</span>
<span class="doccomment">/// hides the intermediate state of producing an AST (the &quot;abstract syntax&quot;).</span>
<span class="doccomment">/// The AST is itself far more complex than the HIR, so this parser serves as a</span>
<span class="doccomment">/// convenience for never having to deal with it at all.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// If callers have more fine grained use cases that need an AST, then please</span>
<span class="doccomment">/// see the [`ast::parse`](ast/parse/index.html) module.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// A `Parser` can be configured in more detail via a</span>
<span class="doccomment">/// [`ParserBuilder`](struct.ParserBuilder.html).</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Parser</span> {
    <span class="ident">ast</span>: <span class="ident">ast::parse::Parser</span>,
    <span class="ident">hir</span>: <span class="ident">hir::translate::Translator</span>,
}

<span class="kw">impl</span> <span class="ident">Parser</span> {
    <span class="doccomment">/// Create a new parser with a default configuration.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The parser can be run with `parse` method. The parse method returns</span>
    <span class="doccomment">/// a high level intermediate representation of the given regular</span>
    <span class="doccomment">/// expression.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// To set configuration options on the parser, use</span>
    <span class="doccomment">/// [`ParserBuilder`](struct.ParserBuilder.html).</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>() -&gt; <span class="ident">Parser</span> {
        <span class="ident">ParserBuilder::new</span>().<span class="ident">build</span>()
    }

    <span class="doccomment">/// Parse the regular expression into a high level intermediate</span>
    <span class="doccomment">/// representation.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">parse</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">pattern</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">hir::Hir</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">ast</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">ast</span>.<span class="ident">parse</span>(<span class="ident">pattern</span>)<span class="question-mark">?</span>;
        <span class="kw">let</span> <span class="ident">hir</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">hir</span>.<span class="ident">translate</span>(<span class="ident">pattern</span>, <span class="kw-2">&amp;</span><span class="ident">ast</span>)<span class="question-mark">?</span>;
        <span class="prelude-val">Ok</span>(<span class="ident">hir</span>)
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="regex_syntax" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>